# coding: utf-8

"""
    GroupDocs.Translation SDK

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 24.3.0
    Contact: anton.perhunov@aspose.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from groupdocs_translation_cloud.models.http_status_code import HttpStatusCode

class CloudHugoResponse(BaseModel):
    """
    CloudHugoResponse
    """
    status: Optional[HttpStatusCode] = None
    message: Optional[StrictStr] = Field(None, description="If file was parsed correctly or text of error")
    frontmatters: Optional[conlist(conlist(StrictStr))] = Field(None, description="Structure of front matter syntax")
    shortcodes: Optional[Dict[str, conlist(conlist(StrictStr))]] = Field(None, description="Structure of short code syntax")
    __properties = ["status", "message", "frontmatters", "shortcodes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CloudHugoResponse:
        """Create an instance of CloudHugoResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if message (nullable) is None
        # and __fields_set__ contains the field
        if self.message is None and "message" in self.__fields_set__:
            _dict['message'] = None

        # set to None if frontmatters (nullable) is None
        # and __fields_set__ contains the field
        if self.frontmatters is None and "frontmatters" in self.__fields_set__:
            _dict['frontmatters'] = None

        # set to None if shortcodes (nullable) is None
        # and __fields_set__ contains the field
        if self.shortcodes is None and "shortcodes" in self.__fields_set__:
            _dict['shortcodes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CloudHugoResponse:
        """Create an instance of CloudHugoResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CloudHugoResponse.parse_obj(obj)

        _obj = CloudHugoResponse.parse_obj({
            "status": obj.get("status"),
            "message": obj.get("message"),
            "frontmatters": obj.get("frontmatters"),
            "shortcodes": obj.get("shortcodes")
        })
        return _obj

